// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_privacy_msgs:msg/PersonalDataProcessor.idl
// generated code does not contain a copyright notice

#ifndef HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__STRUCT_HPP_
#define HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__hri_privacy_msgs__msg__PersonalDataProcessor __attribute__((deprecated))
#else
# define DEPRECATED__hri_privacy_msgs__msg__PersonalDataProcessor __declspec(deprecated)
#endif

namespace hri_privacy_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PersonalDataProcessor_
{
  using Type = PersonalDataProcessor_<ContainerAllocator>;

  explicit PersonalDataProcessor_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data_source_node = "";
      this->user_friendly_source_name = "";
      this->data_purpose = "";
      this->path = "";
    }
  }

  explicit PersonalDataProcessor_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : data_source_node(_alloc),
    user_friendly_source_name(_alloc),
    data_purpose(_alloc),
    path(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data_source_node = "";
      this->user_friendly_source_name = "";
      this->data_purpose = "";
      this->path = "";
    }
  }

  // field types and members
  using _data_source_node_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_source_node_type data_source_node;
  using _user_friendly_source_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _user_friendly_source_name_type user_friendly_source_name;
  using _data_purpose_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_purpose_type data_purpose;
  using _path_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _path_type path;

  // setters for named parameter idiom
  Type & set__data_source_node(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data_source_node = _arg;
    return *this;
  }
  Type & set__user_friendly_source_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->user_friendly_source_name = _arg;
    return *this;
  }
  Type & set__data_purpose(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data_purpose = _arg;
    return *this;
  }
  Type & set__path(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->path = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_privacy_msgs__msg__PersonalDataProcessor
    std::shared_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_privacy_msgs__msg__PersonalDataProcessor
    std::shared_ptr<hri_privacy_msgs::msg::PersonalDataProcessor_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PersonalDataProcessor_ & other) const
  {
    if (this->data_source_node != other.data_source_node) {
      return false;
    }
    if (this->user_friendly_source_name != other.user_friendly_source_name) {
      return false;
    }
    if (this->data_purpose != other.data_purpose) {
      return false;
    }
    if (this->path != other.path) {
      return false;
    }
    return true;
  }
  bool operator!=(const PersonalDataProcessor_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PersonalDataProcessor_

// alias to use template instance with default allocator
using PersonalDataProcessor =
  hri_privacy_msgs::msg::PersonalDataProcessor_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hri_privacy_msgs

#endif  // HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__STRUCT_HPP_
