// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hri_privacy_msgs:msg/PersonalDataProcessor.idl
// generated code does not contain a copyright notice
#include "hri_privacy_msgs/msg/detail/personal_data_processor__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `data_source_node`
// Member `user_friendly_source_name`
// Member `data_purpose`
// Member `path`
#include "rosidl_runtime_c/string_functions.h"

bool
hri_privacy_msgs__msg__PersonalDataProcessor__init(hri_privacy_msgs__msg__PersonalDataProcessor * msg)
{
  if (!msg) {
    return false;
  }
  // data_source_node
  if (!rosidl_runtime_c__String__init(&msg->data_source_node)) {
    hri_privacy_msgs__msg__PersonalDataProcessor__fini(msg);
    return false;
  }
  // user_friendly_source_name
  if (!rosidl_runtime_c__String__init(&msg->user_friendly_source_name)) {
    hri_privacy_msgs__msg__PersonalDataProcessor__fini(msg);
    return false;
  }
  // data_purpose
  if (!rosidl_runtime_c__String__init(&msg->data_purpose)) {
    hri_privacy_msgs__msg__PersonalDataProcessor__fini(msg);
    return false;
  }
  // path
  if (!rosidl_runtime_c__String__init(&msg->path)) {
    hri_privacy_msgs__msg__PersonalDataProcessor__fini(msg);
    return false;
  }
  return true;
}

void
hri_privacy_msgs__msg__PersonalDataProcessor__fini(hri_privacy_msgs__msg__PersonalDataProcessor * msg)
{
  if (!msg) {
    return;
  }
  // data_source_node
  rosidl_runtime_c__String__fini(&msg->data_source_node);
  // user_friendly_source_name
  rosidl_runtime_c__String__fini(&msg->user_friendly_source_name);
  // data_purpose
  rosidl_runtime_c__String__fini(&msg->data_purpose);
  // path
  rosidl_runtime_c__String__fini(&msg->path);
}

bool
hri_privacy_msgs__msg__PersonalDataProcessor__are_equal(const hri_privacy_msgs__msg__PersonalDataProcessor * lhs, const hri_privacy_msgs__msg__PersonalDataProcessor * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // data_source_node
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data_source_node), &(rhs->data_source_node)))
  {
    return false;
  }
  // user_friendly_source_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->user_friendly_source_name), &(rhs->user_friendly_source_name)))
  {
    return false;
  }
  // data_purpose
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data_purpose), &(rhs->data_purpose)))
  {
    return false;
  }
  // path
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->path), &(rhs->path)))
  {
    return false;
  }
  return true;
}

bool
hri_privacy_msgs__msg__PersonalDataProcessor__copy(
  const hri_privacy_msgs__msg__PersonalDataProcessor * input,
  hri_privacy_msgs__msg__PersonalDataProcessor * output)
{
  if (!input || !output) {
    return false;
  }
  // data_source_node
  if (!rosidl_runtime_c__String__copy(
      &(input->data_source_node), &(output->data_source_node)))
  {
    return false;
  }
  // user_friendly_source_name
  if (!rosidl_runtime_c__String__copy(
      &(input->user_friendly_source_name), &(output->user_friendly_source_name)))
  {
    return false;
  }
  // data_purpose
  if (!rosidl_runtime_c__String__copy(
      &(input->data_purpose), &(output->data_purpose)))
  {
    return false;
  }
  // path
  if (!rosidl_runtime_c__String__copy(
      &(input->path), &(output->path)))
  {
    return false;
  }
  return true;
}

hri_privacy_msgs__msg__PersonalDataProcessor *
hri_privacy_msgs__msg__PersonalDataProcessor__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_privacy_msgs__msg__PersonalDataProcessor * msg = (hri_privacy_msgs__msg__PersonalDataProcessor *)allocator.allocate(sizeof(hri_privacy_msgs__msg__PersonalDataProcessor), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hri_privacy_msgs__msg__PersonalDataProcessor));
  bool success = hri_privacy_msgs__msg__PersonalDataProcessor__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hri_privacy_msgs__msg__PersonalDataProcessor__destroy(hri_privacy_msgs__msg__PersonalDataProcessor * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hri_privacy_msgs__msg__PersonalDataProcessor__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__init(hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_privacy_msgs__msg__PersonalDataProcessor * data = NULL;

  if (size) {
    data = (hri_privacy_msgs__msg__PersonalDataProcessor *)allocator.zero_allocate(size, sizeof(hri_privacy_msgs__msg__PersonalDataProcessor), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hri_privacy_msgs__msg__PersonalDataProcessor__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hri_privacy_msgs__msg__PersonalDataProcessor__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__fini(hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hri_privacy_msgs__msg__PersonalDataProcessor__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hri_privacy_msgs__msg__PersonalDataProcessor__Sequence *
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * array = (hri_privacy_msgs__msg__PersonalDataProcessor__Sequence *)allocator.allocate(sizeof(hri_privacy_msgs__msg__PersonalDataProcessor__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__destroy(hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__are_equal(const hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * lhs, const hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hri_privacy_msgs__msg__PersonalDataProcessor__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__copy(
  const hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * input,
  hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hri_privacy_msgs__msg__PersonalDataProcessor);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hri_privacy_msgs__msg__PersonalDataProcessor * data =
      (hri_privacy_msgs__msg__PersonalDataProcessor *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hri_privacy_msgs__msg__PersonalDataProcessor__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hri_privacy_msgs__msg__PersonalDataProcessor__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hri_privacy_msgs__msg__PersonalDataProcessor__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
