// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from hri_privacy_msgs:msg/PersonalDataProcessor.idl
// generated code does not contain a copyright notice

#ifndef HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__FUNCTIONS_H_
#define HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "hri_privacy_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "hri_privacy_msgs/msg/detail/personal_data_processor__struct.h"

/// Initialize msg/PersonalDataProcessor message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_privacy_msgs__msg__PersonalDataProcessor
 * )) before or use
 * hri_privacy_msgs__msg__PersonalDataProcessor__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
bool
hri_privacy_msgs__msg__PersonalDataProcessor__init(hri_privacy_msgs__msg__PersonalDataProcessor * msg);

/// Finalize msg/PersonalDataProcessor message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
void
hri_privacy_msgs__msg__PersonalDataProcessor__fini(hri_privacy_msgs__msg__PersonalDataProcessor * msg);

/// Create msg/PersonalDataProcessor message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_privacy_msgs__msg__PersonalDataProcessor__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
hri_privacy_msgs__msg__PersonalDataProcessor *
hri_privacy_msgs__msg__PersonalDataProcessor__create();

/// Destroy msg/PersonalDataProcessor message.
/**
 * It calls
 * hri_privacy_msgs__msg__PersonalDataProcessor__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
void
hri_privacy_msgs__msg__PersonalDataProcessor__destroy(hri_privacy_msgs__msg__PersonalDataProcessor * msg);

/// Check for msg/PersonalDataProcessor message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
bool
hri_privacy_msgs__msg__PersonalDataProcessor__are_equal(const hri_privacy_msgs__msg__PersonalDataProcessor * lhs, const hri_privacy_msgs__msg__PersonalDataProcessor * rhs);

/// Copy a msg/PersonalDataProcessor message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
bool
hri_privacy_msgs__msg__PersonalDataProcessor__copy(
  const hri_privacy_msgs__msg__PersonalDataProcessor * input,
  hri_privacy_msgs__msg__PersonalDataProcessor * output);

/// Initialize array of msg/PersonalDataProcessor messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_privacy_msgs__msg__PersonalDataProcessor__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
bool
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__init(hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * array, size_t size);

/// Finalize array of msg/PersonalDataProcessor messages.
/**
 * It calls
 * hri_privacy_msgs__msg__PersonalDataProcessor__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
void
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__fini(hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * array);

/// Create array of msg/PersonalDataProcessor messages.
/**
 * It allocates the memory for the array and calls
 * hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence *
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__create(size_t size);

/// Destroy array of msg/PersonalDataProcessor messages.
/**
 * It calls
 * hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
void
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__destroy(hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * array);

/// Check for msg/PersonalDataProcessor message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
bool
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__are_equal(const hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * lhs, const hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * rhs);

/// Copy an array of msg/PersonalDataProcessor messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_privacy_msgs
bool
hri_privacy_msgs__msg__PersonalDataProcessor__Sequence__copy(
  const hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * input,
  hri_privacy_msgs__msg__PersonalDataProcessor__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__FUNCTIONS_H_
