// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_privacy_msgs:msg/PersonalDataProcessor.idl
// generated code does not contain a copyright notice

#ifndef HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__TRAITS_HPP_
#define HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_privacy_msgs/msg/detail/personal_data_processor__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace hri_privacy_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PersonalDataProcessor & msg,
  std::ostream & out)
{
  out << "{";
  // member: data_source_node
  {
    out << "data_source_node: ";
    rosidl_generator_traits::value_to_yaml(msg.data_source_node, out);
    out << ", ";
  }

  // member: user_friendly_source_name
  {
    out << "user_friendly_source_name: ";
    rosidl_generator_traits::value_to_yaml(msg.user_friendly_source_name, out);
    out << ", ";
  }

  // member: data_purpose
  {
    out << "data_purpose: ";
    rosidl_generator_traits::value_to_yaml(msg.data_purpose, out);
    out << ", ";
  }

  // member: path
  {
    out << "path: ";
    rosidl_generator_traits::value_to_yaml(msg.path, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PersonalDataProcessor & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: data_source_node
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_source_node: ";
    rosidl_generator_traits::value_to_yaml(msg.data_source_node, out);
    out << "\n";
  }

  // member: user_friendly_source_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "user_friendly_source_name: ";
    rosidl_generator_traits::value_to_yaml(msg.user_friendly_source_name, out);
    out << "\n";
  }

  // member: data_purpose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_purpose: ";
    rosidl_generator_traits::value_to_yaml(msg.data_purpose, out);
    out << "\n";
  }

  // member: path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path: ";
    rosidl_generator_traits::value_to_yaml(msg.path, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PersonalDataProcessor & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_privacy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_privacy_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_privacy_msgs::msg::PersonalDataProcessor & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_privacy_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_privacy_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_privacy_msgs::msg::PersonalDataProcessor & msg)
{
  return hri_privacy_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_privacy_msgs::msg::PersonalDataProcessor>()
{
  return "hri_privacy_msgs::msg::PersonalDataProcessor";
}

template<>
inline const char * name<hri_privacy_msgs::msg::PersonalDataProcessor>()
{
  return "hri_privacy_msgs/msg/PersonalDataProcessor";
}

template<>
struct has_fixed_size<hri_privacy_msgs::msg::PersonalDataProcessor>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hri_privacy_msgs::msg::PersonalDataProcessor>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hri_privacy_msgs::msg::PersonalDataProcessor>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_PRIVACY_MSGS__MSG__DETAIL__PERSONAL_DATA_PROCESSOR__TRAITS_HPP_
